//
//  ViewController.swift
//  AnimationDemo
//
//  Created by Sarah Abraham on 11/19/18.
//  Copyright © 2018 Sarah Abraham. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var animatedView: UIView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }
    
    @IBAction func fadeIn(sender: UIButton) {
        UIView.animate(withDuration: 1.5, animations: {
            self.animatedView.alpha = 1.0
        }
        )
    }
    
    @IBAction func fadeOut(sender: UIButton) {
        UIView.animate(withDuration: 1.5, animations: {
            self.animatedView.alpha = 0.0
        }
        )
    }
    
    @IBAction func slide(sender: UIButton) {
        if (self.animatedView.center.y == 0.0) {
            UIView.animate(withDuration: 2.0, animations: {
                self.animatedView.center.y = self.view.center.y
            }
            )
        } else {
            UIView.animate(withDuration: 2.0, animations: {
                self.animatedView.center.y = 0.0
            }
            )
        }
    }
    
    @IBAction func spin(sender: UIButton) {
        UIView.animate(withDuration: 1.0, animations: {
            //To get the current angle of view, recover sin(x) and cos(x) from matrix then apply arctan
            //This assumes skews have not been applied
            let viewTransform = self.animatedView.transform
            let angle = atan2f(Float(viewTransform.b), Float(viewTransform.a))
            self.animatedView.transform = CGAffineTransform(rotationAngle: CGFloat(angle + Float.pi/4))
        },
            completion: { finished in
                print(" Rotated once ")
        })
    }
    
    @IBAction func slideAndReturn(sender:UIButton) {
        UIView.animate(withDuration: 2.0, delay: 0.0, options: .curveEaseOut, animations: {
            self.animatedView.center.y = 0.0
        }, completion: { finished in
            UIView.animate(withDuration: 2.0, delay: 1.0, options: .curveEaseOut, animations: {
                self.animatedView.center.y = self.view.center.y
            }, completion: nil
            )
        }
        )
    }
    
    @IBAction func loopedFade(sender:UIButton) {
        UIView.animate(withDuration: 2.0, delay: 0.0, options: [.curveEaseInOut, .autoreverse, .repeat], animations: {
            self.animatedView.alpha = 0.0
        }, completion: { finished in self.animatedView.alpha = 1.0
            })
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

